<template>
  <div
    id="backgroundCover"
    v-bind:style="[coverStyles]"
    @click="emitPopupClosedOnCoverClick"
  ></div>
  <div v-bind:class="[popupClasses]" v-bind:style="[popupStyles]">
    <div id="popupContent">
      <div id="popupTopBar">
        <svg
          height="20"
          width="20"
          @click="emitPopupClosed"
          v-if="conf.displayCloseButton"
        >
          <line
            x1="0"
            y1="0"
            x2="20"
            y2="20"
            stroke="darkblue"
            stroke-width="2"
          />
          <line
            x1="0"
            y1="20"
            x2="20"
            y2="0"
            stroke="darkblue"
            stroke-width="2"
          />
        </svg>
      </div>
      <div id="popupBody" v-bind:style="[popupBodyStyles]">
        <slot></slot>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "Popup",
  props: {
    conf: null,
  },
  emits: ["popup-closed", "action-completed"],
  methods: {
    emitPopupClosedOnCoverClick() {
      if (this.conf.coverCloseOnClick) {
        this.emitPopupClosed();
      }
    },
    emitPopupClosed() {
      this.$emit("popup-closed");
    },
  },
  data() {
    return {
      coverStyles: {
        background: this.conf.coverBackground,
        opacity: this.conf.coverOpacity,
      },
      popupClasses: ["popup"],
      popupStyles: {
        top: `${window.pageYOffset + 50}px`,
      },
      popupBodyStyles: {},
    };
  },
  created() {
    window.setTimeout(
      () => this.popupClasses.push(this.conf.dimensionClass),
      1
    );
    window.setTimeout(() => (this.popupBodyStyles.display = "flex"), 350);
  },
};
</script>

<style scoped>
#backgroundCover {
  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  z-index: 1;
}

.popup {
  background: darkblue;
  padding: 2px;
  width: 0;
  height: 0;
  position: absolute;
  left: 50%;
  transform: translateX(-50%);
  transition: 0.3s;
  z-index: 2;
}

.popup-300-300 {
  width: 300px;
  height: 300px;
}

.popup-400-300 {
  width: 400px;
  height: 300px;
}

.popup-600-800 {
  width: 600px;
  height: 800px;
}

#popupContent {
  width: calc(100% - 20px);
  height: calc(100% - 20px);
  padding: 10px;
  background: white;
}

#popupTopBar {
  display: flex;
  justify-content: flex-end;
}

#popupBody {
  width: 100%;
  height: calc(100% - 30px);
  display: none;
  flex-direction: column;
  justify-content: flex-start;
}

@media (max-width: 600px) {
  .popup-300-300 {
    width: calc(100% - 40px);
  }

  .popup-400-300 {
    width: calc(100% - 40px);
  }

  .popup-600-800 {
    width: calc(100% - 40px);
  }
}
</style>